#################################################################
#								#
#								#
# Here some degree testers and state testers for the		#
# algorithm are defined						#
#								#
#								#
#################################################################




# this procedure is the degree tester
# this is a very important procedure, which tests
# which polynomials can still be used for interpolation

# Input one, the variables we work with
# input two, the matrix we will test
# input three gives us the permitted degree, 
# this menas the degree when we can 
# still interpolate this column
# The output will be a matrix filled with the degrees 
# of the seperate entries 




Deg := proc(vars,numvars,nB,B)
	local i, j, cB, VB, DEGMAT;
	
	# initialization of vars

	cB := coldim(B);

	DEGMAT:=array(1..nB,1..cB,[]);
	VB:=vector(nB,[seq(0,i=1..nB)]);

	for i from 1 to cB do
          for j from 1 to nB do
	    DEGMAT[j,i]:=DegVec(vars,numvars,nB,col(B,i))[j];
          od;
	od;

	
	RETURN(DEGMAT);

end:

#########################################################################

# The next procedure will test the degree of one vector of the matrix B
# the overall degree of all the components 
# will be written in the matrix DEGVB

DegVec := proc(vars,numvars,nB,VecB)
  local i,j,VB;

  # initialization of the vars

  VB:=VecB;

  for i from 1 to numvars do
    for j from 1 to nB do
      VB[j]:=subs(vars[i]=degsearch,VB[j]);
    od;	
  od;
 

  for j from 1 to nB do
    VB[j]:=degree(VB[j],degsearch);
  od;
  
  RETURN(evalm(VB));
end:

####################################################################
#search the columns satisfying specific degree limitations.



DegTestMat := proc(vars,numvars,nB,B,sdeg)
  local cB,i,output;		


  # initializing some vars
  cB:=coldim(B);
  output:=vector(cB,[seq(1,i=1..cB)]); 

  for i from 1 to cB do
    output[i]:=DegTestVec(vars,numvars,col(B,i),sdeg);
  od;

  RETURN(output);
end:

######################################################################

# the next procedure will test of a column of
# given as the second input
# still satisfys the sdegree
# so it still can be operated on
# the output is 1 if it is ok
# the output is 0 when the allowed
# degree has exceeded

DegTestVec := proc(vars,numvars,VB,sdeg)
  local DB,i,output;

  # initializing some vars		
  DB:=DegVec(vars,numvars,nB,VB);

 
  output:=1; 
  for i from 1 to vectdim(DB) do
    if DB[i] > sdeg[i] then
     output:=0;
    fi;

  od;
  RETURN(output);
end: