# In this Procedure one interpolationpoint will be dadded to the
# Matrix B, given as input.

######################################################################
## vars -> list of the variables	                            ##
## P -> vector of the initial polynomials                           ##
## B -> the matrix with the solution                                ##
## IP -> the iteration points                                       ##
## pivot -> the number of the column to be used as pivot            ##
######################################################################

IteratInterpol := proc(vars,numvars,nB,cB,B,IP,IPpoint,pivot,resB,numip)
	local i, j,BTMP;


	
	# adapting the size of the matrix B
	B:=augment(B,matrix(nB,numvars-1,[seq([seq(0,j=1..numvars-1)],i=1..nB)]));
	resB:=augment(resB,matrix(numip,numvars-1,[seq([seq(0,j=1..numvars-1)],i=1..numip)]));
	

	# updating the matrix B and resB in three steps

	# first part with residuals
	for i from 1 to cB do
	  if i <> pivot then 
           B:=addcol(B,pivot,i,-row(resB,IPpoint)[i]/row(resB,IPpoint)[pivot]);
	   resB:=addcol(resB,pivot,i,-row(resB,IPpoint)[i]/row(resB,IPpoint)[pivot]);
 	  fi;	
	od;

	
	# adding the columns
        BTMP:=col(B,pivot);
	for i from 2 to numvars do
          for j from 1 to nB do
            B[j,cB+i-1]:=expand(BTMP[j]*vars[i])-BTMP[j]*IP[IPpoint][i];
          od;
	  #B:=addcol(B,pivot,cB+i-1,vars[i]-IP[IPpoint][i]);

	  for j from 1 to numip do
	    resB[j,cB+i-1]:=resB[j,pivot]*(IP[j][i]-IP[IPpoint][i]);
	  od;
        od; 

	
	# changing the pivot
        for j from 1 to nB do
           B[j,pivot]:=expand(BTMP[j]*vars[1])-BTMP[j]*IP[IPpoint][1];
         od;

        

	for j from 1 to numip do
	   resB[j,pivot]:=resB[j,pivot]*(IP[j][1]-IP[IPpoint][1]);
	od;

	#B:=map(expand,B);

	# in this last part we will delete the zero columns.
	# this means wesearch the highets coefficient in the column, if it is smaller then 
        # a certain value we delete this column.
       
       
	RETURN(matrix(B),cB+numvars-1,resB);
end:


	
	