#########################################################
#							#
#  INITIAL VALUE LOADING FOR THE LOOP  			#
#							#
#########################################################

# the following file will contain the output data
# in text format
datafile:="data.txt";
# if you want to know waht is written in the file:
# check out "writedata.mpl"


# output print
verbose:=1;
# -2. prints nothing only the working example, writes results in file
# -1. print nothing except timings + solution residual
# 0. only timings + problem information
# 1. timings+regular output
# 2. timings+regular ouput+vectors


# set number of digits: DIGITS (standard maple: 10)
Digits:=16:; 


######################################################

# the next variables are for the examples to generate#

######################################################
# if the examples you want to generate always
# have to be the same, remove the following command line
_seed:=randomize();


# vars are the different variables
# input given as list of lists (NOT AS VECTOR) for example 
# varsloop:=[seq([x0,x1],i=1..10)];


#varsloop:=[seq([x0,x1,x2],i=1..2),seq([x0,x1,x2,x3],i=1..2)];
varsloop:=[seq([x0,x1],i=1..11),seq([x0,x1,x2],i=1..4),seq([x0,x1,x2,x3],i=1..4),seq([x0,x1,x2,x3,x4],i=1..4),seq([x0,x1,x2,x3,x4,x5],i=1..4),seq([x0,x1,x2,x3,x4,x5,x6],i=1..4)];
#varsloop:=[[x0,x1]];


# deg is a list of dimension (number of variables + 1)
# and gives the maximum degree of the polynomials you want to
# generate. (corresponding with p0,p1,p2,....pn).
# again the input is a list of lists


#degloop:=[[6,6,6]];
degloop:=[seq([i+1,i+1,i+1],i=1..11),seq([i+1,i+1,i+1,i+1],i=1..4),seq([i+1,i+1,i+1,i+1,i+1],i=1..4),seq([i+1,i+1,i+1,i+1,i+1,i+1],i=1..4),seq([i+1,i+1,i+1,i+1,i+1,i+1,i+1],i=1..4),seq([i+1,i+1,i+1,i+1,i+1,i+1,i+1,i+1],i=1..4)];
#degloop:=[[2,1,1,1],[2,1,1,1],[2,1,1,1,1],[2,1,1,1,1]];



#degloop:=[[5,6],seq([rand(1..3)(),rand(1..3)(),rand(1..3)()],i=1..5)];

# interval wherein the coefficients will be generated:
# standard:= [-100,100]
# will be multiplied with the factor given
coeffactor:=0.01;



#########################################################

# Variables for the program to run			#

#########################################################

# these do not change during different examples, 
# inherent to the problem


# when residual smaller then .. terminate program:
residual:=10.0^(-12):;

# omitting point when residual smaller then
omitres:=10.0^(-10):;
# this means that all the residuals of this
# column are smaller then the given value omitres
# therefore we assume this column is a solution, 
# and dont use it anymore as a pivot.


# choice of interpolationpoints:
# 1. random in the range [-10,10]
# 2. random in the range [-1,1]
# 3. chebyshev points in the range [-1,1]
# 4. equal spaced points in the range [-1,1] 

# this is again a lis of lists, for example
# [[1,2],[3],[1,2,3,4]]
# means first example with interpoaltionpoints 1 and 2
# second example interpolationpoints 3
# third interpolationpoints 1 2 3 4



#ChoiceIPloop:=[[3],[3],[3],[3]];
ChoiceIPloop:=[seq([2,3,4],i=1..11),seq([3],i=1..4),seq([3],i=1..4),seq([3],i=1..4),seq([3],i=1..4),seq([3],i=1..4)];
#ChoiceIPloop:=[[2,1]];



# in case 1 and 2 specify the number of extra interpolationpoints
# in case 3 and 4 the number of extra interpolation points ~ extra



#extraloop:=[seq(20,i=1..4)];
#extraloop:=[10];
extraloop:=[seq(200,i=1..11),seq(200,i=1..4),seq(300,i=1..4),seq(300,i=1..4),seq(400,i=1..4),seq(400,i=1..4)];
